structure Definitions : DEFINITIONS =
struct
   type ('a,'b) iff = (('a -> 'b) * ('b -> 'a))
   datatype ('a,'b) or = L of 'a | R of 'b

   (* It is impossible to create a value of type void,
    * so it is perfect for representing false. *)
   datatype void = Void of void
   type 'a not = 'a -> void
   (* abort is a total function *)
   fun abort (Void v) = abort v
end
